require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/rcas', type: :request do
  # Rca. As you add validations to Rca, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { {title: 'Rca 1', methodology_id: methodology.id} }
  let(:invalid_attributes) { {title: '', methodology_id: methodology.id} }

  let(:user) { FactoryBot.create(:user) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  # let(:rca) { FactoryBot.create(:rca, methodology_id: methodology.id) }

  before :each do
    user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
    user.save!
    sign_in user
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      Rca.create! valid_attributes
      get rcas_url
      expect(response).to be_successful
    end
  end

  describe 'PATCH /reinit_filters_index' do
    it 'updates advancement for all rcas and render rcas index' do
      Rca.create! valid_attributes
      patch rcas_reinit_filters_index_path
      expect(response).to redirect_to(rcas_url(reinit_filters: true))
    end
  end

  describe 'GET /reinit_filters' do
    it 'clear all filters' do
      Rca.create! valid_attributes
      get rcas_reinit_filters_path, params: {}, xhr: true
      expect(response).to be_successful
    end
  end

  describe 'PATCH /reinit_all_advancements' do
    it 'updates advancement for all rcas and render rcas index' do
      Rca.create! valid_attributes
      patch rca_reinit_all_advancements_path
      expect(response).to redirect_to(rcas_url)
    end
  end

  describe 'GET /show' do
    it 'renders a successful response' do
      rca = Rca.create! valid_attributes
      get rca_path(rca)
      expect(response).to be_successful
    end
  end

  describe 'GET /new' do
    it 'renders a successful response' do
      get new_rca_url
      expect(response).to be_successful
    end
  end

  describe 'GET /edit' do
    it 'render a successful response' do
      rca = Rca.create! valid_attributes
      get edit_rca_url(rca)
      expect(response).to be_successful
    end
  end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new Rca' do
        expect {
          post rcas_url, params: { rca: valid_attributes }
        }.to change(Rca, :count).by(1)
      end

      it 'redirects to the created rca' do
        post rcas_url, params: { rca: valid_attributes }
        expect(response).to redirect_to(edit_rca_path(Rca.last))
      end
    end

    context 'with invalid parameters' do
      it 'does not create a new Rca' do
        expect {
          post rcas_url, params: { rca: invalid_attributes }
        }.to change(Rca, :count).by(0)
      end

      it 'renders a successful response (i.e. to display the new template)' do
        post rcas_url, params: { rca: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) { {title: 'Rca new title'} }

      it 'updates the requested rca' do
        rca = Rca.create! valid_attributes
        patch rca_url(rca), params: { rca: new_attributes }
        rca.reload
        expect(rca.title).to eq 'Rca new title'
      end

      it 'redirects to the rca' do
        rca = Rca.create! valid_attributes
        patch rca_url(rca), params: { rca: new_attributes }
        rca.reload
        expect(response).to redirect_to(edit_rca_path(rca))
      end
    end

    context 'with invalid parameters' do
      it 'renders a successful response (i.e. to display the edit template)' do
        rca = Rca.create! valid_attributes
        patch rca_url(rca), params: { rca: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'DELETE /destroy' do
    it 'destroys the requested rca' do
      rca = Rca.create! valid_attributes
      expect {
        delete rca_url(rca)
      }.to change(Rca, :count).by(-1)
    end

    it 'redirects to the rcas list' do
      rca = Rca.create! valid_attributes
      delete rca_url(rca)
      expect(response).to redirect_to(rcas_url)
    end
  end

  describe 'PATCH /advancement_set' do
    it 'updates advancement for requested rca' do
      rca = Rca.create! valid_attributes
      step = methodology.steps_menu.first

      patch rca_advancement_set_path(id: rca.id, step: step.id, advance: 2)

      expect(rca.advancement(step)).to eq 2
    end

    it 'updates advancement redirect to edit rca' do
      rca = Rca.create! valid_attributes
      step = methodology.steps_menu.first

      patch rca_advancement_set_path(id: rca.id, step: step.id, advance: 2)
      expect(response).to redirect_to(edit_rca_path(rca))
    end
  end

  context 'Rca add and del parent' do
    before :each do
      @rca1 = Rca.create!(title: 'Rca 1', methodology_id: methodology.id)
      @rca2 = Rca.create!(title: 'Rca 2', methodology_id: methodology.id)
      @rca3 = Rca.create!(title: 'Rca 3', methodology_id: methodology.id)
      @rca4 = Rca.create!(title: 'Rca 4', methodology_id: methodology.id)
    end

    describe 'GET /rca_add_parent' do
      it 'return a succesfull response and valid rcas list' do
        get rca_add_parent_path, params: {id: @rca1.id}, xhr: true
        
        expect(response).to be_successful

        # expect(@rcas).to contain_exactly(@rca2, @rc3, @rc4)
        expect(response.body).to include(@rca2.title)
        expect(response.body).to include(@rca3.title)
        expect(response.body).to include(@rca4.title)
        expect(response.body).to_not include(@rca1.title)
      end
    end

    describe 'PATCH /rca_add_parent_valid' do
      it 'save a parent to rca1 and redirect' do
        patch rca_add_parent_valid_path(id: @rca1.id, rcas: @rca3.id)

        expect(response).to redirect_to(edit_rca_path(@rca1))

        expect(@rca3.tools_rca_lists&.first&.rcas&.first).to eq @rca1
        expect(@rca1.reload.tools_rca_list&.rcas&.first).to eq @rca1
        expect(@rca1.reload.tools_rca_list&.rca).to eq @rca3
      end
    end

    describe 'DELETE /rca_delete_parent' do
      it 'delete rca1 parent and redirect' do
        @rca1.set_rca_parent(@rca3)
        @rca1.reload

        ### Now delete !
        delete rca_delete_parent_path(id: @rca1.id)

        expect(response).to redirect_to(edit_rca_path(@rca1))

        expect(@rca3.tools_rca_lists&.first&.rcas).to be_empty
        expect(@rca1.reload.tools_rca_list).to be_nil
      end
    end
  end
end
